/*------------------------------------------------------
	Library for Document Analysis System
	(Extended Math. class)
		Written  by H.Goto, Nov. 1994
		Modified by H.Goto, Feb. 1997
		E-Mail: hgot@ecip.tohoku.ac.jp
------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1994-1997  Hideaki Goto

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hideaki Goto, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/


#ifndef	Exmath_h
#define	Exmath_h


class ExMATH {
    private:
	int		xsum,ysum;
	int		xxsum,xysum;
	int		ar,br,alimit;
    public:
	int		counts;

	int		lsinit(int ar,int br,int alimit);
	int		lsputdata(int x,int y);
	int		lsputdata(int x,int y,int wt);
	inline int	_lsputdata(int x,int y);
	inline int	_lsputdata(int x,int y,int wt);
	int		lsgetA(void);
	int		lsgetB(void);
	int		lsgetB2(int a);
	int		lncross(int x0,int y0,int x1,int y1,int x2,int y2,int x3,int y3);
};


inline int ExMATH :: _lsputdata(int x,int y){
	xsum += x;
	ysum += y;
	xxsum += (x * x);
	xysum += (x * y);
	counts += 1;
	return (0);
}


inline int ExMATH :: _lsputdata(int x,int y,int wt){
	xsum += (x * wt);
	ysum += (y * wt);
	xxsum += (x * x * wt * wt);
	xysum += (x * y * wt * wt);
	counts += wt;
	return (0);
}

#endif	/* Exmath_h */

