/*------------------------------------------------------
	Library for Document Analysis System
	(Text-line object file I/O class)
		Written  by H.Goto, Aug. 1996
		Modified by H.Goto, Feb. 1997
		E-Mail: hgot@ecip.tohoku.ac.jp
------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1996-1997  Hideaki Goto

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hideaki Goto, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/


#ifndef	TLfile_h
#define	TLfile_h

#include	<ufilep.h>
#include	"TLobj.h"


class TLFILE : private D4LOAD, private D4SAVE {
    private:
	int		width,height;
	d4file		size;
	int		read_textline(TLOBJ **tl);
    public:
	void		getsize(int *width,int *height);
	void		setsize(int lx,int ly,int lwidth,int lheight, \
				int hx,int hy,int hwidth,int hheight);
	int		load(char *fname,TLGroup *TLGRP);
	int		load_blocks(char *fname,TLGroup ***TLGlist);
	int		save(char *fname,TLGroup *TLGRP,int tlmaskmode);
};


#endif	/* TLfile_h */
