/*------------------------------------------------------
	Library for Document Analysis System
	(TLimage:  Handle Text-Line Images)
		Written  by H.Goto, May  1996
		Modified by H.Goto, Dec. 1996
		Modified by H.Goto, Feb. 1997
		E-Mail: hgot@ecip.tohoku.ac.jp
------------------------------------------------------*/

/*--------------------------------------------------------------------
  Copyright (C) 1996-1997  Hideaki Goto

        All Rights Reserved

  Permission to use, copy, modify, and distribute this software and
  its documentation for any purpose is hereby granted without fee,
  provided that (i) the above copyright notice and this permission
  notice appear in all copies and in supporting documentation, (ii)
  the name of the author, Hideaki Goto, may not be used in any
  advertising or otherwise to promote the sale, use or other
  dealings in this software without prior written authorization
  from the author, (iii) this software may not be used for
  commercial products without prior written permission from the
  author, and (iv) the notice of the modification is specified in
  case of that the modified copies of this software are distributed.

  THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
  THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
  SOFTWARE.
--------------------------------------------------------------------*/

#ifndef	TLimage_h
#define	TLimage_h


#include	"utypes.h"
#include	"ufilep.h"
#include	"siplib.h"

#include	"darstd.h"
#include	"Exmath.h"
#include	"TLobj.h"
#include	"TLproc.h"



class TLImageH : public ExMATH {
    private:
	int		getboxctr;
	int		getboxlnn;
	TLOBJ		*curlninfo;
	int		setboxfirst(TLGroup *TLG,int lnn);
	int		getboxnext(cbox *cb);
	int		getboxnext(cbox *cb,TLrect *rectlist);
	void		lsfitAB(TLrect *rectlist,int off,int rects, \
				int xoff,int *a,int *b);
	void		getuloff(TLrect *rectlist,int off,int len, \
				int cwid,int a,int b,int *uoff,int *loff);
	void		setcovprs(TLrect *rectlist,TLrect *rectlist0,int off,int len, \
			 int cwid,int height,int a,int b,int uoff,int loff,int mode);
	ImgFBD		*getimage_raw(ImgFBD *docimg,TLGroup *TLG,int lnn,int mul);
	ImgFBD		*getimage_rect(ImgFBD *docimg,TLGroup *TLG,int lnn,int mul);
	ImgFBD		*getimage_irect(ImgFBD *docimg,TLGroup *TLG, \
					int lnn,int cwid,int mul);
	ImgFBD		*getimage_lrect(ImgFBD *docimg,TLGroup *TLG, \
					int lnn,int cwid,int mul,int fmul);
    public:
	ImgFBD		*createfb(int xoff,int yoff,int width, \
					int height,int xm,int ym);
	int		deletefb(ImgFBD *dfb);

	int		blkcpy(int xg0,int yg0,int w,int h,ImgFBD *srcfbd,ImgFBD *dstfbd);
	int		blkcpy(cbox *cb,ImgFBD *srcfbd,ImgFBD *dstfbd);
	int		save(char *fname,ImgFBD *dfb);
	int		getcbox(TLGroup *TLG,int lnn,cbox *cb);
	int		getcbox(TLGroup *TLG,int lnn,cbox *cb,TLrect *rectlist);
	double		getskew(TLGroup *TLG,int lnn);

	ImgFBD		*getimage(ImgFBD *docimg,TLGroup *TLG, \
				int lnn,int cwid,int mul,int fmul,int mode);
};


#endif	/* TLimage_h */
