.TH txtori 1 "July 1998"
.SH NAME
txtori \- finds orientations of local text regions
.SH SYNOPSIS
.B txtori
.BR
[\-options]
.BR
\-o 
.I out_file
.BR
.I in_file

.SH DESCRIPTION
txtori is the preprocessor for text line extraction.
txtori finds the orientations of local text regions in 
a document image, and reduces the rectangles which 
are being fed to the program for text line extraction such
as lnextr2(1).
.PP
txtori was designed to reduce the rectangles which
seem to belong to the text line candidates of incorrect orientation
in the text regions printed by proportional fonts.
txtori does not work well for the text regions printed by fixed-width fonts.
.PP
txtori has two modes; the Primitive Rectangle mode 
and the Circumscribing Rectangle mode (Bounding Box mode).
In the Primitive Rectangle mode,
txtori first reads two files containing
the set of rectangles for horizontal and vertical.
Those files can be created by makepr(1).
The filename for the horizontal rectangles 
is given by "
.I in_file
", 
and the filename for the vertical rectangles is 
given by "
.I in_file
V", that is, added a character "V".
txtori finds the local orientations of text lines, 
reduces the rectangles for incorrect orientation, 
and writes the rectangles which are considered to be 
the parts of text lines on two files, one for horizontal and
the other for vertical.
The filename for the horizontal rectangles 
is given by "
.I out_file
", 
and the filename for the vertical rectangles is 
given by "
.I out_file
V".
.PP
In the Circumscribing Rectangle mode (Bounding Box mode),
txtori first reads a file containing
the set of circumscribing rectangles (bounding boxes), which 
can be created by makecr(1).
The filename of the input file
is given by "
.I in_file
".
The input circumscribing rectangles are considered to be
the rectangles for horizontal text lines.
The rectangles for vertical text lines are created automatically 
by the program.
txtori finds the local orientations of text lines, 
reduces the rectangles for incorrect orientation, 
and writes the rectangles which are considered to be 
the parts of text lines on two files, one for horizontal and
the other for vertical.
The filename for the horizontal rectangles 
is given by "
.I out_file
", 
and the filename for the vertical rectangles is 
given by "
.I out_file
V".

.SH OPTIONS
.TP
.B \-crect
Let txtori work in the Circumscribing Rectangle mode (Bounding Box mode).
If this option is omitted, txtori works in the 
Primitive Rectangle mode.
.TP
.B \-pridir
Print direction matrix on screen (out to stdout).
.TP
.B \-ps
.I file 
Export direction matrix to 
.I file
in Postscript.
.TP
.B \-quiet
Suppress printing messages.


.SH EXIT STATUS
The following exit values are returned:
.PD 0
.TP 10
.B 0
Successful completion.
.TP
.B > 0
An error occurred.
.PD

.SH SEE ALSO
makepr(1), makecr(1), lnextr2(1)

.SH NOTES
The width of the Primitive Rectangle is fixed to 16 (pixels), 
and the width of each subregion (see references) is fixed to 64 (pixels).
The resolution of the document image is assumed to be
about 200dpi. In the Primitive Rectangle mode, txtori may
not work well for very small (<4pt) or very large (>20pt) characters.
.PP
Some improvements of the method have been developed since the first
article was written, and have incorporated into this
program.
.PP
This program is just a SAMPLE, so that there may be some limitations or 
reductions.


.SH REFERENCES
"A Framework for Detecting and Selecting Text Line Candidates of 
Correct Orientation " by Hideaki Goto and Hirotomo Aso,
14th International Conference on Pattern Recognition (ICPR98),
August 1998, Brisbane, Australia.
.PP
"Extracting Arbitrarily Oriented Text Lines Using Local Linearity of
Text Line" by Hideaki Goto and Hirotomo Aso,
Technical Report of IEICE, PRMU98-14, pp.9-16 (May 1998). (in Japanese)


.SH AUTHOR
Copyright (C) 1995\-1998 Hideaki Goto
.\" Permission to use, copy, modify, and distribute this software and
.\" its documentation for any purpose is hereby granted without fee,
.\" provided that (i) the above copyright notice and this permission
.\" notice appear in all copies and in supporting documentation, (ii)
.\" the name of the author, Hideaki Goto, may not be used in any
.\" advertising or otherwise to promote the sale, use or other
.\" dealings in this software without prior written authorization
.\" from the author, (iii) this software may not be used for
.\" commercial products without prior written permission from the
.\" author, and (iv) the notice of the modification is specified in
.\" case of that the modified copies of this software are distributed.
.\"
.\" THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND.
.\" THE AUTHOR WILL NOT BE RESPONSIBLE FOR ANY DAMAGE CAUSED BY THIS
.\" SOFTWARE.

E\-Mail: hgot@ecip.tohoku.ac.jp, hgot@aso.ecei.tohoku.ac.jp
